﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Razor_DropDownList_ADO.Net.Models;


using System.Data.SqlClient;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Razor_DropDownList_ADO.Net.Pages
{
    public class IndexModel : PageModel
    {
        public SelectList Fruits { get; set; }

        public void OnGet()
        {
            this.Fruits = new SelectList(PopulateFruits(), "FruitId", "FruitName");
        }

        public void OnPostSubmit(FruitModel fruit)
        {
            string message = "Fruit Name: " + fruit.FruitName;
            message += "\\nFruit Id: " + fruit.FruitId;
            ViewData["Message"] = message;
        }

        private static List<FruitModel> PopulateFruits()
        {
            string constr = @"Data Source=.\SQL2017;Initial Catalog=AjaxSamples;Integrated Security=true";
            List<FruitModel> fruits = new List<FruitModel>();
            using (SqlConnection con = new SqlConnection(constr))
            {
                string query = "SELECT FruitName, FruitId FROM Fruits";
                using (SqlCommand cmd = new SqlCommand(query))
                {
                    cmd.Connection = con;
                    con.Open();
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        while (sdr.Read())
                        {
                            fruits.Add(new FruitModel
                            {
                                FruitName = sdr["FruitName"].ToString(),
                                FruitId = Convert.ToInt32(sdr["FruitId"])
                            });
                        }
                    }
                    con.Close();
                }
            }

            return fruits;
        }
    }
}
